------------------------------------------------------------------------------
--	Caches all items currently equiped items and all items in the bags		--
------------------------------------------------------------------------------
local ItemCache =  FlexBar2:NewModule("ItemCache", "AceEvent-2.0");
-- If this var is incremented, SetDefaults() will be called for this module thus resetting all its settings. Though there are no settings for this module, it has to be declared
ItemCache.Version = 1;

local Cache = {};
ItemCache.Cache = Cache;

function ItemCache:OnInitialize()
	-- Schedule an update on initial loading
    ItemCache.ScheduleUpdate = true;
	-- Schedule a cache update when those events trigger
    self:RegisterBucketEvent("BAG_UPDATE",0.5, function(Bucket) ItemCache.ScheduleUpdate = true; ItemCache:TriggerEvent("FB2_ItemsChanged"); end);
    self:RegisterEvent("UNIT_INVENTORY_CHANGED", function(UnitId) if(UnitId == "player") then ItemCache.ScheduleUpdate = true; ItemCache:TriggerEvent("FB2_ItemsChanged"); end end);
end

function ItemCache:BuildItemCache()
    FlexBar2:Debug("Building ItemCache");
	-- Clear the old cache first
    for ItemLink, _ in pairs(Cache) do
        for Info, _ in pairs(Cache[ItemLink]) do
            Cache[ItemLink][Info] = nil;
        end
    end
	-- Loop through all bags
    for Bag = 0, 4 do
		-- loop through all slots in current bag
        for Slot =1, GetContainerNumSlots(Bag) do
			-- Get itemlink
            local ItemLink = GetContainerItemLink(Bag, Slot);
            if(ItemLink) then
				-- Strip out the SHITTY uniqueID FUCK and replace it by zero
				ItemLink = string.gsub(ItemLink, "(.*):(.-)$", "%1:0");
				-- Put itemlink: in front of the itemlink :p
                ItemLink = "itemlink:" .. ItemLink
				-- Sanity check 
                if(type(Cache[ItemLink]) ~= "table") then Cache[ItemLink] = {}; end
				-- Save bag id & bagslot
                Cache[ItemLink].Bag = Bag;
                Cache[ItemLink].BagSlot = Slot;
            end
        end
    end
	-- Loop through all equiped slots
    for Slot = 0, 23 do
		-- Get itemlink
        local ItemLink = GetInventoryItemLink("player", Slot);
        if(ItemLink) then
			-- Strip out the SHITTY uniqueID FUCK and replace it by zero
				ItemLink = string.gsub(ItemLink, "(.*):(.-)$", "%1:0");
			-- Put itemlink: in front of the itemlink :p
            ItemLink = "itemlink:" .. ItemLink;
			-- Sanity check
            if(type(Cache[ItemLink]) ~= "table") then Cache[ItemLink] = {}; end
			-- Save inventory slot
            Cache[ItemLink].InvSlot = Slot;
        end
    end
end

-- Small function to get something from the cache easely
function ItemCache:GetItemInfo(ItemLink)
	if(ItemLink) then
		-- If an update is scheduled, update before returning stuff
		if(ItemCache.ScheduleUpdate == true) then
			ItemCache:BuildItemCache();
			ItemCache.ScheduleUpdate = false;
		end
		-- Strip out the UniqueID FUCK
		ItemLink = string.gsub(ItemLink, "(.*):(.-)$", "%1:0");
		return Cache[ItemLink] or Cache["itemlink:" .. ItemLink] or false;
	end
end
